#include <arduinoFFT.h>
#include <defs.h>
#include <types.h>

#include <Servo.h>

#define SAMPLES 128             //Must be a power of 2
#define SAMPLING_FREQUENCY 1000 //Hz, must be less than 10000 due to ADC
#define AVERAGE 4

Servo left;
Servo right;
int counter = 0;
int counter2 = 0;


const int enableLow2 = 3;
const int enable_high = 2;
const int enableLow1 = 4;

const int motorL = 5;
const int motorR = 6;
const int trigPinLeft = 7;
const int trigPinRight = 8;
const int echoPinLeft = 11;
const int echoPinRight = 12;

double distanceLeft = 0;
double distanceRight = 0;
bool state = 1;

#define SERVO_SPEED 10  //(minimum number of milliseconds per degree)
int servo1_pos= 180;  // desired angle for servo1
int servo2_pos= 180;  // desired angle for servo2

int phaseDelay = 90;
double left_value = 0;
double right_value = 0;
int i_right = 0;
double samples[AVERAGE];
double average;

 
arduinoFFT FFT = arduinoFFT();
 
unsigned int sampling_period_us;
unsigned long microseconds;
 
double vReal[SAMPLES];
double vImag[SAMPLES];




void setup() {
left.attach(9);
right.attach(10);
pinMode(enableLow1, OUTPUT);
pinMode(enableLow2, OUTPUT);
pinMode(enable_high, OUTPUT);
pinMode(trigPinLeft, OUTPUT); // Sets the trigPin as an Output
pinMode(trigPinRight, OUTPUT); // Sets the trigPin as an Output
pinMode(echoPinLeft, INPUT); // Sets the echoPin as an Input
pinMode(echoPinRight, INPUT); // Sets the echoPin as an Input

pinMode(motorL, OUTPUT);
pinMode(motorR, OUTPUT);
Serial.begin(115200); // Starts the serial communication
sampling_period_us = round(1000000*(1.0/SAMPLING_FREQUENCY));

digitalWrite(enableLow1, LOW);
digitalWrite(enableLow2, LOW);
digitalWrite(enable_high, HIGH);
left.write(0);
right.write(0);
}


void loop() {

  
//  for (int i = 0; i<360; i=i+18)
//  {
//    i_right = (i+phaseDelay)%360;
//    if (i >= 180)
//    {
//      left.write(360-i);
//      delay(50);
//      left_value = left.read();      
//      distanceLeft = UltraSoundSensor(trigPinLeft, echoPinLeft);
//    }
//    else
//    {
//      left.write(i);
//      delay(50);
//      left_value = left.read();
//      distanceLeft = UltraSoundSensor(trigPinLeft, echoPinLeft);
//    }
//    if (i_right >= 180)
//    {
//      right.write(360-i_right);
//      delay(50);
//      right_value = right.read();
//      distanceRight = UltraSoundSensor(trigPinRight, echoPinRight);
//    }
//    else
//    {
//      right.write(i_right);
//      delay(50);
//      right_value = right.read();
//      distanceRight = UltraSoundSensor(trigPinRight, echoPinRight);
//    }
    for (int i = 45; i<135; i=i+18)
    {
      left.write(i);
      right.write(180-i);
      delay(100);
      distanceLeft = UltraSoundSensor(trigPinLeft, echoPinLeft);
      distanceRight = UltraSoundSensor(trigPinRight, echoPinRight);
          Serial.print(distanceLeft);
    Serial.print("  ");
    Serial.println(distanceRight);
    speedControl(distanceLeft, distanceRight);
    }
    for (int i = 135; i>=45; i=i-18)
    {
      left.write(i);
      right.write(180-i);
      delay(100);
      distanceLeft = UltraSoundSensor(trigPinLeft, echoPinLeft);
      distanceRight = UltraSoundSensor(trigPinRight, echoPinRight);
          Serial.print(distanceLeft);
    Serial.print("  ");
    Serial.println(distanceRight);
    speedControl(distanceLeft, distanceRight);
    }

  

//   for(int i = 0; i < AVERAGE-1; i++)
//  {
//    samples[i+1] = samples[i];
//  }
//  samples[0] = analogRead(0);
//
//  average = 0;
//  for(int i = 0; i < AVERAGE; i++)
//  {
//    average = average+samples[i];
//  }
//  average = average/4;
//  Serial.println(average);


}

double UltraSoundSensor(int trigPin, int echoPin) {
  double distance = 0, duration = 0;
// Clears the trigPin
digitalWrite(trigPin, LOW);
delayMicroseconds(2);
// Sets the trigPin on HIGH state for 10 micro seconds
digitalWrite(trigPin, HIGH);
delayMicroseconds(10);
digitalWrite(trigPin, LOW);
// Reads the echoPin, returns the sound wave travel time in microseconds
duration = pulseIn(echoPin, HIGH, 100000);
// Calculating the distance
return distance= duration*0.034/2;

}

void speedControl(double distanceL, double distanceR)
{
  double treshold = 250;
  double tresholdFullPower = 0;
//  if (distanceL < 100 && distanceL != 0)
//  {
//    analogWrite(motorL, 1023);
//  }
  if (distanceL < treshold && distanceL != 0)
  {
    double powerL = 1-(distanceL-tresholdFullPower)/(treshold-tresholdFullPower);
    analogWrite(motorL, powerL*1023);
  }
  else
  {
    analogWrite(motorL, 0);
  }
//  if (distanceR < 100 && distanceR != 0)
//  {
//    analogWrite(motorR, 1023);
//  }
  if (distanceR < treshold && distanceR != 0)
  {
    double powerR = 1-(distanceR-tresholdFullPower)/(treshold-tresholdFullPower);
    analogWrite(motorR, powerR*1023);
  }
  else
  {
    analogWrite(motorR, 0);
  }
}


